//+------------------------------------------------------------------+
//|                                                     Miracle Quad |
//|                                                   Copyright 2021 |
//|                                   Mockup EA Settings Version 0.1 |
//+------------------------------------------------------------------+

#property strict
#property indicator_chart_window

//--- input parameters

extern string a1 = "----------- Trade Manager Settings -----------";
enum trademanager
  {
   None = 1,
   Volume_Only = 2,
   Silver_Mode = 3,
   Platinum_Mode = 4,
   Gold_Mode = 5,
  };
extern trademanager TradeManagerMode = None;

enum trademanagerstatusareapos
  {
   Top_Right = 1,
   Top_Left = 2,
   Bottom_Right = 3,
   Bottom_Left = 4,
  };
extern trademanagerstatusareapos TradeManagerStatusAreaChartPosition  = Top_Right;

enum trademanagerstatusareafontsize
  {
   Small = 1,
   Medium = 2,
   Large = 3,
   Extra_Large = 4,
  };
extern trademanagerstatusareafontsize TradeManagerStatusAreaFontSize = Large;

extern string a2 = "----------- Risk Settings -----------";

enum risksettingmode
  {
   Manual = 1,
   ATR_1_Percent = 2,
   ATR_1_and_a_Half_Percent = 3,
   ATR_2_Percent = 4,
   ATR_2_and_a_Half_Percent = 5,
   ATR_3_Percent = 6,
   ATR_3_and_a_Half_Percent = 7,
   ATR_4_Percent = 8,
   ATR_4_and_a_Half_Percent = 9,
   ATR_5_Percent = 10,
   };

extern risksettingmode TradeStopLoss = ATR_1_and_a_Half_Percent;
extern risksettingmode TradeTakeProfit = ATR_2_and_a_Half_Percent;


extern string a3 = "----------- Trading Settings -----------";

enum YesNo
  {
   Yes = 1,
   No = 2,
  };
extern YesNo ShowSignalArrows = Yes;

input color BuyArrow = clrGreen;

input color SellArrow = clrGreen;

extern trademanagerstatusareafontsize SignalArrowSize = Medium;

extern YesNo ShowPsychLevels  = No;

extern YesNo ShowVolumeProfile  = No;


extern string b1 = "----------- Automatic Fibonacci ZigZag Settings  -----------";

input color FortyPercentMarkerLine   = clrBlue;   // Horizontal line to mark current 40% level if a buy/sell signal was generated

extern string c1 = "----------- Regular ZigZag Settings  -----------";

input int inpDepth = 6;

extern string d1 = "----------- First Non Repainting ZigZag Settings  -----------";

input int Period1 = 20;

extern string e1 = "----------- Second Non Repainting ZigZag Settings  -----------";

input int Period2 = 5;

extern string f1 = "----------- Volume Moving Average Settings  -----------";

input int MovingAverage = 14;

extern string g1 = "----------- Alert Settings -----------";

extern YesNo ShowNotifications = Yes;

extern YesNo ShowPopupMessage  = Yes;

extern YesNo Play_Sound  = Yes;

extern YesNo SendEmail  = No;

extern YesNo SMSPush  = No;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
