//+------------------------------------------------------------------+
//|                                                    Auto Fibo.mq4 |
//|                           https://www.mql5.com/en/users/iwori_fx |
//| 12/23/2020 - Modified by Tony for Telmo                          |
//+------------------------------------------------------------------+

#property strict
#property indicator_chart_window

//--- input parameters
input string   inpName           = "Fibo_";       // Fibo Prefix Name
input int      inpDepth          = 21;             // ZigZag Depth
input int      inpDeviation      = 12;              // ZigZag Deviation
input int      inpBackStep       = 6;              // ZigZag BackStep
input int      inpLeg            = 1;              // ZigZag Leg
input int      inpNlegs          = 10;             // N ZigZag's
input double   inpMinSize        = 5.0;            // ZigZag Min Size
input bool     inpRay            = false;          // Ray

input string   sUp               = "---";          // Fibo Up
input int      inpLineWidthUp    = 2;              // Fibo Line Width Up
input color    inpLineColorUp    = clrRed;         // Fibo Line Color Up
input color    inpLevelsColorUp1   = clrNONE;        // Level 1 Color Up
input color    inpLevelsColorUp2   = clrSteelBlue;   // Level 2 Color Up
input color    inpLevelsColorUp3   = clrSteelBlue;   // Level 3 Color Up
input color    inpLevelsColorUp4   = clrSteelBlue;   // Level 4 Color Up
input color    inpLevelsColorUp5   = clrSteelBlue;   // Level 5 Color Up
input color    inpLevelsColorUp6   = clrSteelBlue;   // Level 6 Color Up
input color    inpLevelsColorUp7   = clrSteelBlue;   // Level 7 Color Up
input color    inpLevelsColorUp8   = clrSteelBlue;   // Level 8 Color Up
input color    inpLevelsColorUp9   = clrSteelBlue;   // Level 9 Color Up

input double   inpLevelUp1         = 0.0;            // Level 1 Up
input double   inpLevelUp2         = 0.0;            // Level 2 Up
input double   inpLevelUp3         = 0.0;            // Level 3 Up
input double   inpLevelUp4         = 50.0;           // Level 4 Up
input double   inpLevelUp5         = 57.9;           // Level 5 Up
input double   inpLevelUp6         = 100.0;          // Level 6 Up
input double   inpLevelUp7         = 0.0;            // Level 7 Up
input double   inpLevelUp8         = 0.0;            // Level 8 Up
input double   inpLevelUp9         = 0.0;            // Level 9 Up

input int      inpWidthUp1         = 1;           // Width 1 Up
input int      inpWidthUp2         = 1;           // Width 2 Up
input int      inpWidthUp3         = 1;           // Width 3 Up
input int      inpWidthUp4         = 1;           // Width 4 Up
input int      inpWidthUp5         = 1;           // Width 5 Up
input int      inpWidthUp6         = 1;           // Width 6 Up
input int      inpWidthUp7         = 1;           // Width 7 Up
input int      inpWidthUp8         = 1;           // Width 8 Up
input int      inpWidthUp9         = 1;           // Width 9 Up

input ENUM_LINE_STYLE inpStyleUp1  = STYLE_SOLID; // Style 1 Up
input ENUM_LINE_STYLE inpStyleUp2  = STYLE_SOLID; // Style 2 Up
input ENUM_LINE_STYLE inpStyleUp3  = STYLE_SOLID; // Style 3 Up
input ENUM_LINE_STYLE inpStyleUp4  = STYLE_SOLID; // Style 4 Up
input ENUM_LINE_STYLE inpStyleUp5  = STYLE_SOLID; // Style 5 Up
input ENUM_LINE_STYLE inpStyleUp6  = STYLE_SOLID; // Style 6 Up
input ENUM_LINE_STYLE inpStyleUp7  = STYLE_SOLID; // Style 7 Up
input ENUM_LINE_STYLE inpStyleUp8  = STYLE_SOLID; // Style 8 Up
input ENUM_LINE_STYLE inpStyleUp9  = STYLE_SOLID; // Style 9 Up


input string   sDn               = "---";          // Fibo Dn
input int      inpLineWidthDn    = 2;              // Fibo Line Width Dn
input color    inpLineColorDn    = clrRed;         // Fibo Line Color Dn
input color    inpLevelsColorDn1   = clrNONE;        // Level 1 Color Dn
input color    inpLevelsColorDn2   = clrSteelBlue;   // Level 2 Color Dn
input color    inpLevelsColorDn3   = clrSteelBlue;   // Level 3 Color Dn
input color    inpLevelsColorDn4   = clrSteelBlue;   // Level 4 Color Dn
input color    inpLevelsColorDn5   = clrSteelBlue;   // Level 5 Color Dn
input color    inpLevelsColorDn6   = clrSteelBlue;   // Level 6 Color Dn
input color    inpLevelsColorDn7   = clrSteelBlue;   // Level 7 Color Dn
input color    inpLevelsColorDn8   = clrSteelBlue;   // Level 8 Color Dn
input color    inpLevelsColorDn9   = clrSteelBlue;   // Level 9 Color Dn

input double   inpLevelDn1         = 0.0;            // Level 1 Dn
input double   inpLevelDn2         = 0.0;            // Level 2 Dn
input double   inpLevelDn3         = 0.0;            // Level 3 Dn
input double   inpLevelDn4         = 50.0;           // Level 4 Dn
input double   inpLevelDn5         = 57.9;           // Level 5 Dn
input double   inpLevelDn6         = 100.0;          // Level 6 Dn
input double   inpLevelDn7         = 0.0;            // Level 7 Dn
input double   inpLevelDn8         = 0.0;            // Level 8 Dn
input double   inpLevelDn9         = 0.0;            // Level 9 Dn

input int      inpWidthDn1         = 1;           // Width 1 Dn
input int      inpWidthDn2         = 1;           // Width 2 Dn
input int      inpWidthDn3         = 1;           // Width 3 Dn
input int      inpWidthDn4         = 1;           // Width 4 Dn
input int      inpWidthDn5         = 1;           // Width 5 Dn
input int      inpWidthDn6         = 1;           // Width 6 Dn
input int      inpWidthDn7         = 1;           // Width 7 Dn
input int      inpWidthDn8         = 1;           // Width 8 Dn
input int      inpWidthDn9         = 1;           // Width 9 Dn

input ENUM_LINE_STYLE inpStyleDn1  = STYLE_SOLID; // Style 1 Dn
input ENUM_LINE_STYLE inpStyleDn2  = STYLE_SOLID; // Style 2 Dn
input ENUM_LINE_STYLE inpStyleDn3  = STYLE_SOLID; // Style 3 Dn
input ENUM_LINE_STYLE inpStyleDn4  = STYLE_SOLID; // Style 4 Dn
input ENUM_LINE_STYLE inpStyleDn5  = STYLE_SOLID; // Style 5 Dn
input ENUM_LINE_STYLE inpStyleDn6  = STYLE_SOLID; // Style 6 Dn
input ENUM_LINE_STYLE inpStyleDn7  = STYLE_SOLID; // Style 7 Dn
input ENUM_LINE_STYLE inpStyleDn8  = STYLE_SOLID; // Style 8 Dn
input ENUM_LINE_STYLE inpStyleDn9  = STYLE_SOLID; // Style 9 Dn


//--- global variables
double   levels[9][2];     // Levels Array
int width[9][2];
color clr[9][2];
ENUM_LINE_STYLE style[9][2];
string sub;
double   point = _Point;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

   gvd("FibDirection");

// Set Levels Array
   levels[0][0] = inpLevelUp1;
   levels[1][0] = inpLevelUp2;
   levels[2][0] = inpLevelUp3;
   levels[3][0] = inpLevelUp4;
   levels[4][0] = inpLevelUp5;
   levels[5][0] = inpLevelUp6;
   levels[6][0] = inpLevelUp7;
   levels[7][0] = inpLevelUp8;
   levels[8][0] = inpLevelUp9;

   width[0][0] = inpWidthUp1;
   width[1][0] = inpWidthUp2;
   width[2][0] = inpWidthUp3;
   width[3][0] = inpWidthUp4;
   width[4][0] = inpWidthUp5;
   width[5][0] = inpWidthUp6;
   width[6][0] = inpWidthUp7;
   width[7][0] = inpWidthUp8;
   width[8][0] = inpWidthUp9;

   clr[0][0] = inpLevelsColorUp1;
   clr[1][0] = inpLevelsColorUp2;
   clr[2][0] = inpLevelsColorUp3;
   clr[3][0] = inpLevelsColorUp4;
   clr[4][0] = inpLevelsColorUp5;
   clr[5][0] = inpLevelsColorUp6;
   clr[6][0] = inpLevelsColorUp7;
   clr[7][0] = inpLevelsColorUp8;
   clr[8][0] = inpLevelsColorUp9;

   style[0][0] = inpStyleUp1;
   style[1][0] = inpStyleUp2;
   style[2][0] = inpStyleUp3;
   style[3][0] = inpStyleUp4;
   style[4][0] = inpStyleUp5;
   style[5][0] = inpStyleUp6;
   style[6][0] = inpStyleUp7;
   style[7][0] = inpStyleUp8;
   style[8][0] = inpStyleUp9;

   levels[0][1] = inpLevelDn1;
   levels[1][1] = inpLevelDn2;
   levels[2][1] = inpLevelDn3;
   levels[3][1] = inpLevelDn4;
   levels[4][1] = inpLevelDn5;
   levels[5][1] = inpLevelDn6;
   levels[6][1] = inpLevelDn7;
   levels[7][1] = inpLevelDn8;
   levels[8][1] = inpLevelDn9;

   width[0][1] = inpWidthDn1;
   width[1][1] = inpWidthDn2;
   width[2][1] = inpWidthDn3;
   width[3][1] = inpWidthDn4;
   width[4][1] = inpWidthDn5;
   width[5][1] = inpWidthDn6;
   width[6][1] = inpWidthDn7;
   width[7][1] = inpWidthDn8;
   width[8][1] = inpWidthDn9;

   clr[0][1] = inpLevelsColorDn1;
   clr[1][1] = inpLevelsColorDn2;
   clr[2][1] = inpLevelsColorDn3;
   clr[3][1] = inpLevelsColorDn4;
   clr[4][1] = inpLevelsColorDn5;
   clr[5][1] = inpLevelsColorDn6;
   clr[6][1] = inpLevelsColorDn7;
   clr[7][1] = inpLevelsColorDn8;
   clr[8][1] = inpLevelsColorDn9;

   style[0][1] = inpStyleDn1;
   style[1][1] = inpStyleDn2;
   style[2][1] = inpStyleDn3;
   style[3][1] = inpStyleDn4;
   style[4][1] = inpStyleDn5;
   style[5][1] = inpStyleDn6;
   style[6][1] = inpStyleDn7;
   style[7][1] = inpStyleDn8;
   style[8][1] = inpStyleDn9;

   sub = "fibo_";

   point = _Point;
   if(_Digits==1 || _Digits==3 || _Digits==5)
      point *= 10.0;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
// To Delete Fibonacci
   ObjectsDeleteAll(0,inpName);
   gvd("FibDirection");
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   Calc();
//--- return value of prev_calculated for next call
   return(rates_total);
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Calc()
  {
   int N = fmax(1,inpNlegs);
   datetime times[];
   double price[];
   string aux;

   ArrayResize(times,N+1);
   ArrayResize(price,N+1);
//Print(N);

// Get Times and Price ZigZag Values.
   if(!GetZZ(times, price))
      return;

   for(int i=0; i<ArraySize(times)-1; i++)
     {
      for(int j=0; j<9; j++)
        {
         aux = (string)i+(string)j;
         FiboDraw(inpName+aux, times[i+1], price[i+1], times[i], price[i], j); // Create new Fibonacci
         /*
         if(ObjectFind(0, inpName+aux)<0) FiboDraw(inpName+aux, times[i+1], price[i+1], times[i], price[i], j); // Create new Fibonacci
         else FiboMove(inpName+aux, times[i+1], price[i+1], times[i], price[i], j);                                     // Move current Fibonacci
         */
        }
     }
   ChartRedraw();
  }


//+------------------------------------------------------------------+
//| FiboMove function                                                |
//+------------------------------------------------------------------+
void FiboMove(string name, datetime time_1, double price_1, datetime time_2, double price_2, int j)
  {
// Move current Fibonacci
   ObjectMove(0, name, 0, time_1, price_1); // Move first point of the fibo
   ObjectMove(0, name, 1, time_2, price_2); // Move second point of the fibo
   FiboSetLevels(name, price_1, price_2, j);    // Set Levels of the fibo
   ChartRedraw();                            // Refresh chart
  }
//+------------------------------------------------------------------+
//| FiboDraw function                                                |
//+------------------------------------------------------------------+
bool FiboDraw(const string      name,                    // object name
              datetime          time_1,
              double            price_1,
              datetime          time_2,
              double            price_2,
              int               j=0)
  {
   if(ObjectFind(0,name)==0)
      ObjectDelete(0,name);
   if(price_1==price_2)
      return(false);
   long chart_ID=0;
   int sub_window=0;
   color clrFibo = price_2>price_1? inpLineColorUp : inpLineColorDn;
   int fibo_width = price_2>price_1? inpLineWidthUp : inpLineWidthDn;
   int shift = price_2>price_1? 0 : 1;

   if(price_2>price_1)
     {
      gvs("FibDirection",1);
     }
   else
     {
      gvs("FibDirection",0);
     }


   if(fabs(levels[j][shift])<_Point)
      return(false);

   if(inpMinSize>_Point && fabs(price_1-price_2)/point<inpMinSize)
      return(false);

   ResetLastError();

// Create Fibonacci Object

   if(!ObjectCreate(chart_ID, name, OBJ_FIBO, sub_window, time_1, price_1, time_2, price_2))
     {
      Print(__FUNCTION__,
            ": failed to create \"Fibonacci Retracement\"! Error code = ", GetLastError());
      return(false);
     }
//--- set fibonacci object properties
   ObjectSetInteger(chart_ID, name, OBJPROP_COLOR, clrFibo);   // Set Fibo Color
   ObjectSetInteger(chart_ID, name, OBJPROP_STYLE, STYLE_SOLID); // Set Fibo Line Style
   ObjectSetInteger(chart_ID, name, OBJPROP_WIDTH, fibo_width);   // Set Fibo Line Width
   ObjectSetInteger(chart_ID, name, OBJPROP_BACK, false);      // Set Fibo To Front
   ObjectSetInteger(chart_ID, name, OBJPROP_SELECTABLE, false); // Set Fibo Not Selectable
   ObjectSetInteger(chart_ID, name, OBJPROP_SELECTED, false);  // Set Fibo Not Selected
   ObjectSetInteger(chart_ID, name, OBJPROP_RAY_RIGHT, inpRay); // Set Fibo Ray
   ObjectSetInteger(chart_ID, name, OBJPROP_HIDDEN, true);    // Set Fibo Hidden in Object List
   ObjectSetInteger(chart_ID, name, OBJPROP_ZORDER, 0);

// Set Fibonacci Levels
   FiboSetLevels(name, price_1, price_2, j);

//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| FiboSetLevels function                                           |
//+------------------------------------------------------------------+
bool FiboSetLevels(const string      name,                    // object name
                   double            price_1,                // array price
                   double            price_2,
                   int j)                                    // levels color
  {
   if(price_1==price_2)
      return(false);
   long chart_ID=0;
   int sub_window=0;
   string str="";
   int shift = price_2>price_1? 0 : 1;

   ResetLastError();

// Define number of levels
   ObjectSetInteger(chart_ID, name, OBJPROP_LEVELS, 1);
   ObjectSetDouble(chart_ID, name, OBJPROP_LEVELVALUE, 0, levels[j][shift]/100.0);   // Set Level Value
   ObjectSetInteger(chart_ID, name, OBJPROP_LEVELSTYLE, 0, style[j][shift]);         // Set Level Line Style
   ObjectSetInteger(chart_ID, name, OBJPROP_LEVELWIDTH, 0, width[j][shift]);         // Set Level Line Width
   ObjectSetInteger(chart_ID, name, OBJPROP_LEVELCOLOR, 0, clr[j][shift]);           // Set Level Color


// Set Levels descriptions
   if(fabs(levels[j][shift])>_Point)
     {
      str = DoubleToString(levels[j][shift], 1) + "%  ";                         // Set % levels value
      ObjectSetString(chart_ID, name, OBJPROP_LEVELTEXT, 0, str);       // Set Description Text
     }
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| GetZZ function                                                   |
//+------------------------------------------------------------------+
bool GetZZ(datetime &time[], double &price[])
  {
   bool ret= false;
   int leg = (int)MathMax(1, inpLeg);
   int cnt = 0;
   int idx = 0;
   double zz=0.0;

   for(int i=0; i<Bars-1; i++)
     {
      zz=iCustom(_Symbol, 0, "ZigZag", inpDepth, inpDeviation, inpBackStep, 0, i);
      if(zz<=0.0 || zz==EMPTY_VALUE || zz>1000000.0)
         continue;
      cnt++;
      if(cnt<leg)
         continue;
      time[idx]=Time[i];
      price[idx]=zz;
      idx++;
      if(idx>=ArraySize(time))
        {
         ret=true;
         break;
        }
     }

   return ret;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double gvg(string Variable_Name)
  {
   return(GlobalVariableGet(StringSubstr(WindowExpertName(),0,25)+Symbol()+Period()+ Variable_Name));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool gvs(string Variable_Name,double Value)
  {
   return (GlobalVariableSet(StringSubstr(WindowExpertName(),0,25)+Symbol()+Period()+ Variable_Name, Value));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool gvd(string Variable_Name)
  {
   return (GlobalVariableDel(StringSubstr(WindowExpertName(),0,25)+Symbol()+Period()+ Variable_Name));
  }
//+------------------------------------------------------------------+
bool gvc(string Variable_Name)
  {
   return (GlobalVariableCheck(StringSubstr(WindowExpertName(),0,25)+Symbol()+Period()+ Variable_Name));
  }
//+------------------------------------------------------------------+
